package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class SceneEvents_0 extends SceneScript
{
	public var _RandomNumber:Float;
	public var _DominoPlayed:Array<Dynamic>;
	public var _DominoChosen:Bool;
	public var _Dominoamount:Float;
	public var _DominoPicker:Float;
	public var _ScenCount:String;
	public var _CardsInPlay:Array<Dynamic>;
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("RandomNumber", "_RandomNumber");
		_RandomNumber = 0.0;
		nameMap.set("Domino Played", "_DominoPlayed");
		nameMap.set("DominoChosen", "_DominoChosen");
		_DominoChosen = false;
		nameMap.set("Domino amount", "_Dominoamount");
		_Dominoamount = 0.0;
		nameMap.set("Domino Picker", "_DominoPicker");
		_DominoPicker = 0.0;
		nameMap.set("ScenCount", "_ScenCount");
		_ScenCount = "";
		nameMap.set("CardsInPlay", "_CardsInPlay");
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_DominoChosen = false;
		_Dominoamount = 30;
		while(!(_DominoChosen == true))
		{
			_DominoPicker = randomInt(0, Std.int((_Dominoamount - 1)));
			trace(_DominoPicker);
			/* Get dominoes for this scene */
			if((_DominoPicker == 29))
			{
				_DominoChosen = true;
			}
			else
			{
				_DominoChosen = false;
			}
		}
		
		/* =========================== On Actor =========================== */
		addMouseOverActorListener(getActor(1), function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 3 == mouseState)
			{
				reloadCurrentScene(null, createCrossfadeTransition(0.5));
			}
		});
		
		/* =========================== On Actor =========================== */
		addMouseOverActorListener(getActor(2), function(mouseState:Int, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && 3 == mouseState)
			{
				switchScene(GameModel.get().scenes.get(1).getID(), null, createCrossfadeTransition(0.5));
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}